package cz.fi.muni.pa165.entity;

import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.UUID;

@Getter
@Setter
@MappedSuperclass
public abstract class BaseEntity {

    @Id
    @GeneratedValue(generator = "UUID")
    @GenericGenerator(
            name = "UUID",
            strategy = "org.hibernate.id.UUIDGenerator"
    )
    @NotNull
    @Column(updatable = false)
    protected UUID id;

    public BaseEntity() {}

    public BaseEntity(UUID id) {
        this.id = id;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;

        if (this.getClass().isInstance(o)) {
            return this.id == ((BaseEntity) o).id;
        }

        return false;
    }

    @Override
    public int hashCode() {
        return 31 * id.hashCode();
    }
}
